
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Poultry_lotsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const poultry_lots = await db.poultry_lots.create(
            {
                id: data.id || undefined,
        
        code: data.code
        ||
        null
            ,
            
        name: data.name
        ||
        null
            ,
            
        start_date: data.start_date
        ||
        null
            ,
            
        status: data.status
        ||
        null
            ,
            
        initial_count: data.initial_count
        ||
        null
            ,
            
        current_count: data.current_count
        ||
        null
            ,
            
        deaths_count: data.deaths_count
        ||
        null
            ,
            
        mortality_rate: data.mortality_rate
        ||
        null
            ,
            
        housing_location: data.housing_location
        ||
        null
            ,
            
        notes: data.notes
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await poultry_lots.setManager_user( data.manager_user || null, {
            transaction,
        });
        

        

        

        return poultry_lots;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const poultry_lotsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                code: item.code
            ||
            null
            ,
            
                name: item.name
            ||
            null
            ,
            
                start_date: item.start_date
            ||
            null
            ,
            
                status: item.status
            ||
            null
            ,
            
                initial_count: item.initial_count
            ||
            null
            ,
            
                current_count: item.current_count
            ||
            null
            ,
            
                deaths_count: item.deaths_count
            ||
            null
            ,
            
                mortality_rate: item.mortality_rate
            ||
            null
            ,
            
                housing_location: item.housing_location
            ||
            null
            ,
            
                notes: item.notes
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const poultry_lots = await db.poultry_lots.bulkCreate(poultry_lotsData, { transaction });

        // For each item created, replace relation files
        

        return poultry_lots;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        

        const poultry_lots = await db.poultry_lots.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.code !== undefined) updatePayload.code = data.code;
        
        
        if (data.name !== undefined) updatePayload.name = data.name;
        
        
        if (data.start_date !== undefined) updatePayload.start_date = data.start_date;
        
        
        if (data.status !== undefined) updatePayload.status = data.status;
        
        
        if (data.initial_count !== undefined) updatePayload.initial_count = data.initial_count;
        
        
        if (data.current_count !== undefined) updatePayload.current_count = data.current_count;
        
        
        if (data.deaths_count !== undefined) updatePayload.deaths_count = data.deaths_count;
        
        
        if (data.mortality_rate !== undefined) updatePayload.mortality_rate = data.mortality_rate;
        
        
        if (data.housing_location !== undefined) updatePayload.housing_location = data.housing_location;
        
        
        if (data.notes !== undefined) updatePayload.notes = data.notes;
        
        
        updatePayload.updatedById = currentUser.id;

        await poultry_lots.update(updatePayload, {transaction});

        
        
        if (data.manager_user !== undefined) {
            await poultry_lots.setManager_user(
              
              data.manager_user,
              
              { transaction }
            );
        }
        

        
        

        

        return poultry_lots;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const poultry_lots = await db.poultry_lots.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of poultry_lots) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of poultry_lots) {
                await record.destroy({transaction});
            }
        });


        return poultry_lots;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const poultry_lots = await db.poultry_lots.findByPk(id, options);

        await poultry_lots.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await poultry_lots.destroy({
            transaction
        });

        return poultry_lots;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const poultry_lots = await db.poultry_lots.findOne(
            { where },
            { transaction },
        );

        if (!poultry_lots) {
            return poultry_lots;
        }

        const output = poultry_lots.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.egg_collections_poultry_lot = await poultry_lots.getEgg_collections_poultry_lot({
            transaction
        });
        
        
        output.treatments_poultry_lot = await poultry_lots.getTreatments_poultry_lot({
            transaction
        });
        
        
        output.alerts_poultry_lot = await poultry_lots.getAlerts_poultry_lot({
            transaction
        });
        
        
        
        
        
        output.manager_user = await poultry_lots.getManager_user({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        

        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.users,
        as: 'manager_user',
        
        where: filter.manager_user ? {
          [Op.or]: [
            { id: { [Op.in]: filter.manager_user.split('|').map(term => Utils.uuid(term)) } },
            {
              firstName: {
                [Op.or]: filter.manager_user.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.code) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'poultry_lots',
                        'code',
                        filter.code,
                    ),
                };
            }
            
            if (filter.name) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'poultry_lots',
                        'name',
                        filter.name,
                    ),
                };
            }
            
            if (filter.housing_location) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'poultry_lots',
                        'housing_location',
                        filter.housing_location,
                    ),
                };
            }
            
            if (filter.notes) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'poultry_lots',
                        'notes',
                        filter.notes,
                    ),
                };
            }
            

            
            

            
            if (filter.start_dateRange) {
                const [start, end] = filter.start_dateRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    start_date: {
                    ...where.start_date,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    start_date: {
                    ...where.start_date,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.initial_countRange) {
                const [start, end] = filter.initial_countRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    initial_count: {
                    ...where.initial_count,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    initial_count: {
                    ...where.initial_count,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.current_countRange) {
                const [start, end] = filter.current_countRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    current_count: {
                    ...where.current_count,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    current_count: {
                    ...where.current_count,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.deaths_countRange) {
                const [start, end] = filter.deaths_countRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    deaths_count: {
                    ...where.deaths_count,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    deaths_count: {
                    ...where.deaths_count,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.mortality_rateRange) {
                const [start, end] = filter.mortality_rateRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    mortality_rate: {
                    ...where.mortality_rate,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    mortality_rate: {
                    ...where.mortality_rate,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.status) {
                where = {
                    ...where,
                status: filter.status,
            };
            }
            


      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.poultry_lots.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset, ) {
        let where = {};
        
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'poultry_lots',
                        'name',
                        query,
                    ),
                ],
            };
        }

        const records = await db.poultry_lots.findAll({
            attributes: [ 'id', 'name' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['name', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.name,
        }));
    }

    
};

